# +-----------------------------------------------------------------------+
# | pLoader - a Perl photo uploader for Piwigo                            |
# +-----------------------------------------------------------------------+
# | Copyright(C) 2008      Piwigo Team                  http://piwigo.org |
# +-----------------------------------------------------------------------+
# | This program is free software; you can redistribute it and/or modify  |
# | it under the terms of the GNU General Public License as published by  |
# | the Free Software Foundation                                          |
# |                                                                       |
# | This program is distributed in the hope that it will be useful, but   |
# | WITHOUT ANY WARRANTY; without even the implied warranty of            |
# | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
# | General Public License for more details.                              |
# |                                                                       |
# | You should have received a copy of the GNU General Public License     |
# | along with this program; if not, write to the Free Software           |
# | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
# | USA.                                                                  |
# +-----------------------------------------------------------------------+
package Uploader::Object2;
use strict;

use Data::Dumper;
use base qw/
               Class::Accessor::Fast
           /; 

__PACKAGE__->mk_accessors(     
    qw/
        accessors
        frame_callbacks
      /
);






# Set control values with accessor
sub SetControlValues {
    my ( $self ) = @_;
    
    my $accessors = $self->accessors;
    
    # accessor_name => [ sub {}, control_id ]
    map {
    	my $control_id = $_;
    	my $ctrl = $self->FindWindow($control_id) ;

        my $accessor = $accessors->{$control_id};
    	eval {
    		$ctrl->ChangeValue(
    	            $accessor->()
    	        );
    	};
    	
    	if($@){
    	eval {
    		$ctrl->SetLabel(
    	            $accessor->()
    	        );
    	};
    		
        }
    }
    keys %$accessors;
}

# Get values from controls. Set callback accessors with these values
sub GetControlValues {
    my ( $self ) = @_;

    my $accessors = $self->accessors;

    # accessor_name => [ sub {}, control_id ]
    map {
    	my ( $accessor, $control_id) = @{$accessors->{$_}};
    	
    	eval {
            $accessor->(
       	        $self->FindWindow($control_id)->GetValue()
       	    );
       	};

        if($@){
            eval {
                $accessor->(
       	            $self->FindWindow($control_id)->GetLabel()
       	        );
       	    };
       	};
    }
    keys %$accessors;
}


sub GetControlValue {
    my( $self, $control_id ) = @_;
    
    my $value;
    eval {
    	my $ctrl = $self->FindWindow(
    	    $control_id
    	);
    	
    	$value = $ctrl->GetValue;
    	
    	$self->accessors->{$control_id}->(
            $value
    	);
    };
    
    return $value;
}






1;